/***************************************************************************
                          groupreader.h  -  description                              
                             -------------------                                         
    begin                : Sun Jun 13 1999                                           
    copyright            : (C) 1999 by Roberto Alsina                         
    email                : ralsina@unl.edu.ar                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef GROUPREADER_H
#define GROUPREADER_H

#include <qsplitter.h>
#include "article.h"

/**
  *@author Roberto Alsina
  */

class BaseGroup;
class QListView;
class QListViewItem;
class NewKrnDoc;
class KMReaderWin;
class ArticleItem;

class GroupReader : public QSplitter
{
    Q_OBJECT
public:
    GroupReader(QWidget *parent, NewKrnDoc *_doc);
    ~GroupReader();
    QListView *artList;
    void setGroup(BaseGroup *group);
    void insertArtTree(ArtTreeNode *root,ArticleItem *parent=0);
    BaseGroup *group;
    ArticleList list;
    KMReaderWin *body;
    NewKrnDoc *doc;
public slots:
    void openArticle(QListViewItem *);
    void rightClicked(QListViewItem *);
};

#endif



