/***************************************************************************
                          newkrndoc.h  -  description                              
                             -------------------                                         
    begin                : Tue Jun  8 20:40:39 /etc/localtime 1999
                                           
    copyright            : (C) 1999 by Roberto Alsina                         
    email                : ralsina@unl.edu.ar                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef NEWKRNDOC_H
#define NEWKRNDOC_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "basegroup.h"
#include <qobject.h>

class QObjectLVI;
class GroupReader;
class KMReaderWin;
/**
  * This class provides base functionality for your application document
  */
class NewKrnDoc : public QObject
{
public:
    /** Constructor for the fileclass of the application */
    NewKrnDoc(QObject*);
    /**  */
    void subscribeGroup(const char *name);
    /**  */
    void createFolder (const char *path);
    /** Destructor for the fileclass of the application */
    ~NewKrnDoc();

    void newServer();
    void serverProperties(const char *profile);
    void getActive(const char *server, QObjectLVI *locked);
    void openGroup(BaseGroup *group, QObjectLVI *blocked, GroupReader *greader);
    void updateGroup(BaseGroup *group, QObjectLVI *blocked);
    void showArticle(BaseGroup *group, QObjectLVI *blocked,const char *ID,KMReaderWin *widget);
    void setRead (const char *ID, bool read=true);
    //		void downloadArticles(Group *group,ArticleList list);
};

#endif // NEWKRNDOC_H
















